#!/bin/bash

if [ "$(id -u)" != "0" ]; then
	echo Executar como root ou sudo $0
	exit
fi
echo "Instalando o Biblivre5..."

# suporte para a lingua portuguesa BR.
apt update
apt -y install `check-language-support -l pt`
echo ""
echo "+======================================================================================+"
echo "| Quando aparecer a seguinte opção na tela do terminal:                                |"
echo "| Configuration file '/etc/apt/apt.conf.d/01autoremove'                                |"
echo "| Pressione Y para instalar a versao do mantenedor do pacote                           |"
echo "+======================================================================================+"
echo "Pressione ENTER para continuar a instalação"
	read #pausa

apt -y install apt firefox-locale-pt hunspell-pt-br
rm -r /var/lib/apt/lists/* -vf

# Corrigindo o encoding do Postgres para poder usar banco de dados latin1 ou outro
cp ./files/environment /etc
chmod 644 /etc/environment
cp ./files/locale  /etc/default/locale
chmod 644 /etc/default/locale
echo "pt_BR pt_BR.ISO-8859-1" >> /etc/locale.alias
rm /var/lib/locales/supported.d/en
cp ./files/br /var/lib/locales/supported.d/
chmod 644 /var/lib/locales/supported.d/br
localedef pt_BR -i pt_BR -f ISO-8859-1
localedef pt_BR.ISO-8859-1 -i pt_BR -f ISO-8859-1
localedef pt_BR.ISO8859-1 -i pt_BR -f ISO-8859-1
echo ""
echo "+======================================================================================+"
echo "| Na primeira tela selecione com a tecla spacebar pt_BR ISO-8859-1 e pt_BR.UTF-8 UTF-8 |"
echo "| Com a tecla Tab navegue até OK e de ENTER                                            |"
echo "| Na segunda tela proceda da mesma maneira e selecione somente pt_BR.UTF-8             |"
echo "+======================================================================================+"
echo "Pressione ENTER para continuar a instalação"
	read #pausa
dpkg-reconfigure locales
locale-gen --purge
locale-gen
########## Fim da adaptação da Distro ChaletOS ao sistema Brasileiro ###################

# Adicionando os repositórios para o java e postgreSQL 9.1
apt-add-repository -y ppa:webupd8team/java
wget --quiet -O - https://www.postgresql.org/media/keys/ACCC4CF8.asc | \
  apt-key add -
sh -c 'echo "deb http://apt.postgresql.org/pub/repos/apt/ xenial-pgdg main" >> /etc/apt/sources.list.d/postgresql.list'
apt -y update
apt -y install oracle-java8-installer
apt -y install apache2 apache2-utils authbind postgresql-9.1 libtcnative-1

arch=`uname -m`
if [ "$arch" == "x86_64" ]
then
    ln -s /usr/lib/x86_64-linux-gnu/libtcnative-1.so /usr/lib/libtcnative-1.so
    apt -y remove flashplugin-installer
    sh -c "echo 'deb http://archive.canonical.com/ubuntu $(lsb_release -cs) partner' >> /etc/apt/sources.list"
    apt update
    apt -y install adobe-flashplugin
else
    ln -s /usr/lib/i386-linux-gnu/libtcnative-1.so /usr/lib/libtcnative-1.so
fi

cp /etc/postgresql/9.1/main/pg_hba.conf /etc/postgresql/9.1/main/pg_hba.conf.bak.original 
cp /etc/postgresql/9.1/main/postgresql.conf /etc/postgresql/9.1/main/postgresql.conf.bak.original 
cp ./files/pg_hba.conf /etc/postgresql/9.1/main/ 
chmod 644 /etc/postgresql/9.1/main/pg_hba.conf
cp ./files/postgresql.conf /etc/postgresql/9.1/main/
chmod 644 /etc/postgresql/9.1/main/postgresql.conf
cp ./files/biblivre5.conf /etc/apache2/conf-available/
chmod 644 /etc/apache2/conf-available/biblivre5.conf
a2enconf biblivre5
a2enmod proxy_http
a2enmod include
a2enmod actions
a2enmod ssl
a2enmod asis
service apache2 reload

# Instalacao do tomcat 7.0.70 - mesma versao usada no Biblivre 5 windowsOS
wget http://archive.apache.org/dist/tomcat/tomcat-7/v7.0.70/bin/apache-tomcat-7.0.70.tar.gz
tar xvzf apache-tomcat-7.0.70.tar.gz
cp -r apache-tomcat-7.0.70 /opt
ln -s /opt/apache-tomcat-7.0.70 /opt/tomcat
wget https://jdbc.postgresql.org/download/postgresql-9.1-903.jdbc4.jar
cp postgresql-9.1-903.jdbc4.jar /opt/tomcat/lib
cp ./files/tomcat /etc/init.d
chmod +x /etc/init.d/tomcat
update-rc.d tomcat defaults
systemctl daemon-reload
cp ./files/*war /opt/tomcat/webapps
service tomcat start
chmod 777 /opt/tomcat/logs/catalina.out

# Instalacao da base de dados Biblivre 5
sudo -u postgres bash -c "psql < createdatabase.sql"
sudo -u postgres bash -c "psql biblivre4 < biblivre5.sql"

# Instalacao do icone
cp ./files/Biblivre5.png /usr/share/icons/
desktop-file-install --dir=/usr/local/share/applications ./files/BiblivreV.desktop
# xdg-desktop-icon install --novendor /usr/local/share/applications/BiblivreV.desktop

# Configuracao de acesso remoto
cp ./files/context.xml /opt/apache-tomcat-7.0.70/webapps/Biblivre4/META-INF
echo ""
echo "+===========================================================================================+"
echo "| Pressione ENTER e o arquivo de configuração se abrirá.                                    |"
echo "| Na ultima linha, insira o IP fixo do computador no lugar de 000.000.000.000.              |"
echo "| Quando terminar a edição, salve e feche o arquivo e a instalação irá continuar.           |"
echo "| salve e feche o arquivo e a instalação irá continuar.                                     |"
echo "| Caso queira pular esta etapa simplesmente feche o arquivo que a instalação continuara.    |"
echo "+===========================================================================================+"
       read #pausa
mousepad /opt/tomcat/webapps/Biblivre4/META-INF/context.xml
echo ""
echo "+===========================================================================================+"
echo "| Pressione ENTER e o arquivo de configuração se abrirá. No campo -IPv4 local connections-  |"
echo "| insira o IP fixo do computador no lugar de 000.000.000.000 e                              |"
echo "| remova o caracter -#- existente no início da linha. Quando terminar a edição,             |"
echo "| salve e feche o arquivo e a instalação irá continuar.                                     |"
echo "| Caso queira pular esta etapa simplesmente feche o arquivo que a instalação continuara.    |"
echo "+===========================================================================================+"
      read #pausa
mousepad /etc/postgresql/9.1/main/pg_hba.conf
service tomcat restart
service postgresql restart
service apache2 restart

# Pacotes opcionais
apt -y install hplip-gui xrdp remmina gufw light-locker-settings
# apt -y install intel-microcode

# Correção do problema de DNS
cp ./files/NetworkManager.conf /etc/NetworkManager
chmod 644 /etc/NetworkManager/NetworkManager.conf

# Configuracao do firewall
ufw enable
ufw allow 80
ufw allow 8080/tcp
ufw allow 3389/tcp
ufw allow in "Apache Full"
ufw reload

# Upgrade do sistema
echo ""
echo "+=======================================================================+"
echo "| lsb release = keep ou N (manter)                                      |"
echo "| grub = update (versao do mantenedor do pacote)                        |"
echo "| 50unattended-upgrades.ucftmp = update (versao do mantenedor do pacote)|"
echo "+=======================================================================+"
echo "Pressione ENTER para continuar"
	read #pausa
# rm /etc/apt/apt.conf.d/50unattended-upgrades.ucf-dist
apt -y upgrade
apt -y autoremove

echo ""
echo "+=======================================================================+"
echo "| Para acessar digite no seu navegador: localhost/Biblivre5             |"
echo "| Atencao para o B maiusculo                                            |"
echo "| OU                                                                    |"
echo "| Clique no icone presente na Barra de Menus > Outros > Bibilivre       |"
echo "| OU                                                                    |"
echo "| usuário=admin                                                         |"
echo "| senha=abracadabra                                                     |"
echo "+=======================================================================+"
echo "Pressione ENTER para reiniciar o computador"
	read #pausa
reboot
###########################################################################
# Change Log:
# 18/07/2018 - Script v1.2 - adição do pacote bloqueador de sessão light-locker-settings e remoção do arquivo "bib5-install-2.sh" 
#              por questoes de incompatibilidade com outras distros baseadas no Debian. Modificado por Renan Calliari.
# 30/11/2017 - Correção do problema de DNS, configuracao de firewall, compatiblização com a arquitetura x86_64 
#              e melhorias na configuração do acesso remoto. Modificado por Renan Calliari.
# 30/01/2017 - Script v1.1 - Resolvido o problema de restauração e geração de backups com a instalacao manual
#              do Apache Tomcat na mesma versao da plataforma Microsoft.  
#              Instalacao dos pacotes Java Oracle 8 e PostgreSQL-9.1 para maior compatibilidade. Adicao de icone no menu. 
#              Resolução de dependência do Apache Tomcat com a instalação do pacote libtcnative-1.
#              Adicionado configuracao de rede para acesso remoto. Modificado por Renan Calliari.
# 07/06/2016 - Script v1.0: script inicial desenvolvido por Augusto Solfa.



